var qahm              = qahm || {};
qahm.initBehData      = false;
qahm.initDate         = new Date();
qahm.readersName      = null;
qahm.readersBodyIndex = 0;
qahm.rawName          = null;
qahm.speedMsec        = 0;
qahm.useMyAjax        = true;

// cookieが有効か判定
qahm.isEnableCookie = function(){
	document.cookie = 'y';
	if ( document.cookie === '' ) {
		return false;
	} else {
		return true;
	}
};

// cookie値を連想配列として取得する
qahm.getCookieArray = function(){
	var arr = new Array();
	if ( document.cookie !== '' ) {
		var tmp = document.cookie.split( '; ' );
		for (var i = 0;i < tmp.length;i++) {
			var data     = tmp[i].split( '=' );
			arr[data[0]] = decodeURIComponent( data[1] );
		}
	}
	return arr;
};


if ( ! qahm.isEnableCookie() ) {
	console.error( 'qa: Measurement failed because cookie is invalid.' );
	exit;
}

let action        = 'action=init_session_data';
let nonce         = '&nonce=' + encodeURIComponent( qahm.nonce_init );
let tracking_hash = '&tracking_hash=' + encodeURIComponent( qahm.tracking_hash );
let url           = '&url=' + encodeURIComponent( location.href );
let title         = '&title=' + encodeURIComponent( document.title );
let wp_qa_type    = '&wp_qa_type=' + encodeURIComponent( qahm.type );
let wp_qa_id      = '&wp_qa_id=' + encodeURIComponent( qahm.id );
let referrer      = '&referrer=' + encodeURIComponent( document.referrer );
let country       = '&country=' + encodeURIComponent( (navigator.userLanguage||navigator.browserLanguage||navigator.language).substr(0,2) );
let sendStr       = action + nonce + tracking_hash + url + title + wp_qa_type + wp_qa_id + referrer + country;
let newAjaxUrl    = qahm.plugin_dir_url + 'qahm-ajax.php';

let xhr = new XMLHttpRequest();
xhr.open( 'POST', newAjaxUrl, true );
xhr.setRequestHeader( 'Content-Type', 'application/x-www-form-urlencoded' );
xhr.send( sendStr );

// qahm-ajax通信
xhr.onload = function () {
	try {
		let data = JSON.parse( xhr.response );
		if ( data && data.readers_name ) {
			qahm.readersName      = data.readers_name;
			qahm.readersBodyIndex = data.readers_body_index;
			qahm.rawName          = data.raw_name;
			qahm.initBehData      = true;
			console.log( 'qa: init success.' );
		} else {
			throw new Error();
		}
	} catch (e) {
		// admin-ajax通信
		qahm.useMyAjax = false;
		action  = 'action=qahm_ajax_init_session_data';
		sendStr = action + nonce + tracking_hash + url + title + wp_qa_type + wp_qa_id + referrer + country;

		xhr = new XMLHttpRequest();
		xhr.open( 'POST', qahm.ajax_url, true );
		xhr.setRequestHeader( 'Content-Type', 'application/x-www-form-urlencoded' );
		xhr.send( sendStr );
		xhr.onload = function () {
			try {
				let data = JSON.parse( xhr.response );
				if ( data && data.readers_name ) {
					qahm.readersName      = data.readers_name;
					qahm.readersBodyIndex = data.readers_body_index;
					qahm.rawName          = data.raw_name;
					qahm.initBehData      = true;
					console.log( 'qa: init success.' );
				} else {
					throw new Error( 'qa: init failed. HttpStatus: ' + xhr.statusText );
				}
			} catch (e) {
				console.error( e.message );
			}
		}
	}
}
