<?php
/**
 * Created by PhpStorm.
 * User: maruyama
 * Date: 2022/08/27
 * Time: 16:01
 */

//return wp-setting.php at line141
define('SHORTINIT', true);
//IMPORTANT: Change with the correct path to wp-load.php in your installation
require '../../../wp-load.php' ;
require_once '../../../wp-settings.php' ;
require_once ABSPATH . WPINC . '/l10n.php';
//require( ABSPATH . WPINC . '/capabilities.php' );
//require( ABSPATH . WPINC . '/class-wp-user.php' );
//require( ABSPATH . WPINC . '/user.php' );
//require( ABSPATH . WPINC . '/kses.php' );
//require( ABSPATH . WPINC . '/rest-api.php' );


wp_plugin_directory_constants();

$GLOBALS['wp_plugin_paths'] = array();

//wp_cookie_constants();
//require_once ABSPATH . WPINC . '/pluggable.php';
//require_once ABSPATH . WPINC . '/pluggable-deprecated.php';

require_once ABSPATH . WPINC . '/link-template.php';


/**
 * [ ! ] DO NOT include the plugin main file since WP6.1
 */
//require_once 'qahm.php';//=ERROR

//call qahm files
require_once 'qahm-const.php';
require_once 'class-qahm-base.php';
$qahm_base = new QAHM_Base;
$qahm_base->init_wp_filesystem(); //<-Needed!
require_once 'class-qahm-time.php';
require_once 'class-qahm-log.php';
require_once 'class-qahm-file-base.php';
require_once 'class-qahm-file-data.php';
require_once 'class-qahm-behavioral-data.php';


// work around for apache_request_headers
if( !function_exists('apache_request_headers') ) {
	function apache_request_headers() {
		$arh = array();
		$rx_http = '/\AHTTP_/';
		foreach ($_SERVER as $key => $val) {
			if ( preg_match( $rx_http, $key ) ) {
			  $arh_key = preg_replace( $rx_http, '', $key );
			  $rx_matches = array();
			  // do some nasty string manipulations to restore the original letter case
			  // this should work in most cases
			  $rx_matches = explode( '_', $arh_key );
			  if ( count($rx_matches) > 0 and strlen($arh_key) > 2 ) {
				foreach ( $rx_matches as $ak_key => $ak_val ) $rx_matches[$ak_key] = ucfirst( $ak_val );
				$arh_key = implode( '-', $rx_matches );
			  }
			  $arh[$arh_key] = $val;
			}
		}
		return( $arh );
	}
}


//qahm start
$behave         = new QAHM_Behavioral_Data;
$base           = new QAHM_Base;
$owndomain      = $_SERVER['SERVER_NAME'];
$allowed_origin = [ $owndomain ];
$req_headers    = apache_request_headers( );
$req_origin     = '';
if ( array_key_exists( 'Origin', $req_headers ) ) {
	$req_origin = $req_headers['Origin'];
}
if ( array_key_exists( 'ORIGIN', $req_headers ) ) {
	$req_origin = $req_headers['ORIGIN'];
}
if ( array_key_exists( 'origin', $req_headers ) ) {
	$req_origin = $req_headers['origin'];
}
$is_own_domain  = true;
$orgin          = '';
$action         = $base->wrap_filter_input( INPUT_POST, 'action' );

// allowed domain?
if ( $req_origin !== '' ) {
    $is_allowed = false;
    foreach ( $allowed_origin as $domain ) {
        $host = parse_url( $req_origin, PHP_URL_HOST );
        if ( $host === $domain ) {
            $orgin = $req_origin;
            if ($host === $owndomain ) {
                $is_own_domain = true;
            }
            $is_allowed = true;
            break;
        }
    }
    if ( ! $is_allowed ) {
        http_response_code(404);
        exit;
    }
}

//check tracking_hash
$tracking_hash  = $base->wrap_filter_input( INPUT_POST, 'tracking_hash' );
if ( ! $behave->check_tracking_hash( $tracking_hash ) ) {
    http_response_code(404);
    exit;
}



// ok, start behavioral data
$errmsg = '';

switch ( $action ) {
    case 'init_session_data':
        $qa_id      = $base->wrap_filter_input( INPUT_COOKIE, 'qa_id' );
        $wp_qa_type = $base->wrap_filter_input( INPUT_POST, 'wp_qa_type' );
        $wp_qa_id   = $base->wrap_filter_input( INPUT_POST, 'wp_qa_id' );
        $title      = $base->wrap_filter_input( INPUT_POST, 'title' );
        $url        = $base->wrap_filter_input( INPUT_POST, 'url' );
        $ref        = $base->wrap_filter_input( INPUT_POST, 'referrer' );
        $country    = $base->wrap_filter_input( INPUT_POST, 'country' );
        $ua         = $base->wrap_filter_input( INPUT_SERVER, 'HTTP_USER_AGENT' );
        if ( empty( $ref ) ) {
            $ref = 'direct';
        }
        $url = mb_strtolower( $url );
        $ref = mb_strtolower( $ref );

        //init
        $data = $behave->init_session_data( $qa_id, $wp_qa_type, $wp_qa_id, $title, $url, $ref, $country, $ua ) ;
        return_json( $data, $is_own_domain, $orgin );
        break;

    case 'update_msec':
        $readers_name       = $base->wrap_filter_input( INPUT_POST, 'readers_name' );
        $readers_body_index = (int) $base->wrap_filter_input( INPUT_POST, 'readers_body_index' );
        $speed_msec         = (int) $base->wrap_filter_input( INPUT_POST, 'speed_msec' );
        $behave->update_msec( $readers_name, $readers_body_index, $speed_msec );
        break;

    case 'record_behavioral_data':
        if ( $behave->is_maintenance() ) {
            http_response_code(500);
            exit;
        }
        $is_pos   = $base->wrap_filter_input( INPUT_POST, 'is_pos' );
        $is_pos   = ( $is_pos === 'true' ) ? true : false;
        $is_click = $base->wrap_filter_input( INPUT_POST, 'is_click' );
        $is_click = ( $is_click === 'true' ) ? true : false;
        $is_event = $base->wrap_filter_input( INPUT_POST, 'is_event' );
        $is_event = ( $is_event === 'true' ) ? true : false;

        $raw_name       = $base->wrap_filter_input( INPUT_POST, 'raw_name' );
        $readers_name   = $base->wrap_filter_input( INPUT_POST, 'readers_name' );
        $type           = $base->wrap_filter_input( INPUT_POST, 'type' );
        $id             = $base->wrap_filter_input( INPUT_POST, 'id' );
        $ua             = $base->wrap_filter_input( INPUT_POST, 'ua' );
        if( ! $ua ) {
            $ua = $_SERVER['HTTP_USER_AGENT'];
        }
        $output = $behave->record_behavioral_data( $is_pos, $is_click, $is_event, $raw_name, $readers_name, $type, $id, $ua );
        echo $output;
        break;

    default:
        http_response_code(404);
        exit;
}

exit;



function return_json ( $data, $is_own_domain = true, $origin = '') {
    if ( ! $is_own_domain ) {
        header("Access-Control-Allow-Origin: {$origin}");
    }
    header("Content-Type: application/json; charset=utf-8");
    echo json_encode($data);
    exit;
}